#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  clrLimeGreen
#property indicator_color2  clrOrange
#property indicator_color3  clrGray
#property indicator_color4  clrRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_style4  STYLE_DOT
#property strict

//
//
//

input int                MaPeriod    = 36;
input ENUM_MA_METHOD     MaMethod    = MODE_SMA;
input ENUM_APPLIED_PRICE MaPrice     = PRICE_CLOSE;
input ENUM_APPLIED_PRICE Price       = PRICE_CLOSE;
input bool               inpShowDiff = false;
input int                SigPeriod   = 5;
input ENUM_MA_METHOD     SigMethod   = MODE_SMMA;

double up[],dn[],val[],sig[];
struct sGlobalStruct
{
   int     lim;
   double  diff;
};
sGlobalStruct glo;

//------------------------------------------------------------------
//
//------------------------------------------------------------------

int OnInit()
{
   SetIndexBuffer(0,up,INDICATOR_DATA); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,dn,INDICATOR_DATA); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,val,INDICATOR_DATA);SetIndexStyle(2,inpShowDiff?DRAW_LINE:DRAW_NONE);
   SetIndexBuffer(3,sig,INDICATOR_DATA);SetIndexStyle(3,DRAW_LINE);
return(INIT_SUCCEEDED);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------

int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
   glo.lim  = fmin(rates_total-prev_calculated+1,rates_total-1);
   
   //
   //
   //

   for(int i=glo.lim; i >= 0; i--)
   {
      val[i] = (iMA(_Symbol,_Period,1,0,MODE_SMA,Price,i)-iMA(_Symbol,_Period,MaPeriod,0,MaMethod,MaPrice,i))/(_Point*pow(10,fmod(_Digits,2)));
      if (val[i]>0)
            { up[i] = val[i]; dn[i] = EMPTY_VALUE; }
      else  { dn[i] = val[i]; up[i] = EMPTY_VALUE; }
   }  for(int i=glo.lim; i>=0; i--) sig[i] = iMAOnArray(val,rates_total,SigPeriod,0,SigMethod,i);
return(rates_total);
}

